Fix mountpoint after full fs transfer if needed
[zfs-ubuntu/.git] / zfs-replicate-all
index 6f105d673064f450780fd13305edc79b8ca5fb35..54f96eb97b042072217d00dea8573b45f4171581 100755 (executable)
@@ -14,11 +14,12 @@ logfile="$logdir/zfs-replicate.log"
 mylogfile="$logdir/zfs-replicate-all.log"
 date=`date`
 starttime=`date +%s`
+tmpfile=`mktemp`
 
 # Make sure we aren't already running
 SCRIPT_NAME=${0##*/}
-PROCESS_LIST=`tempfile`
-ps -ef | grep -e "$SCRIPT_NAME" | grep -v grep | grep -v $$ | grep -v $PPID >> $PROCESS_LIST
+PROCESS_LIST=`mktemp`
+ps -ef | grep -e "$SCRIPT_NAME" | grep -v grep | grep -v tail | grep -v less | grep -v $$ | grep -v $PPID >> $PROCESS_LIST
 if [[ $? == 0 ]]; then
    echo "$date Another $SCRIPT_NAME process is already running" >> $mylogfile
    cat $PROCESS_LIST >> $mylogfile
@@ -50,6 +51,17 @@ cleanup_and_exit() {
 }
 trap cleanup_and_exit INT
 
+fatal_and_exit() {
+  # echo message to terminal
+  echo -e 2>&1 "$1"
+  # send email notification
+  echo -e "$1" | $mailx -s "zfs-replicate-all on $hostname failed" "$2"
+  # exit with bad return code unless 3rd argument was defined that says not to
+  if [[ -z "$3" ]]; then
+    exit 1
+  fi
+}
+
 # This function executes the replicate command and checks the stoptime
 replicate() { 
   zfs-replicate $*  >> $logfile 2>&1
@@ -61,7 +73,7 @@ replicate() {
 
 # This function obtains the date a given snapshot was created in epoch seconds
 snapshot_age() {
-  snapshot=${local_pool}/${1}${previous_backup_marker}
+  snapshot=${backup_pool}/${1}${previous_backup_marker}
   $zfs list -t snapshot ${snapshot} > /dev/null 2>&1
   if [ $? == 0 ]; then
     $zfs get creation ${snapshot} > /dev/null 2>&1
@@ -77,35 +89,83 @@ snapshot_age() {
   fi
 }
 
-# Obtain the zpool guid for the local pool
-local_pool_guid=`zpool get guid $local_pool 2>&1 | grep $local_pool | awk '{ print $3 }'`
-zpool get guid $local_pool > /dev/null 2>&1
+# Replicate every zfs filesystem specified in the config file
+echo "$date ZFS replicate started" >> $logfile
+echo "$date ZFS replicate started" | tee -a $mylogfile
+
+# Loop over each backup pool
+backup_pools=$backup_pool
+for backup_pool in $backup_pools; do
+
+# Import the local backup pool if needed and the option is given to do so, else error out
+zpool list -H $backup_pool > $tmpfile 2>&1
 if [ $? != 0 ]; then
-  echo >&2 "-E- Unable to extract the guid for the local pool: $local_pool"
-  exit 1
+  if [[ $import_export_backup_pool == 1 ]]; then
+    zpool import -f $backup_pool >> $tmpfile 2>&1
+    if [ $? != 0 ]; then
+      msgs=`cat $tmpfile`
+      fatal_and_exit "-E- unable to import the backup pool '$backup_pool' on $hostname: $msgs" "$mailto"
+    fi
+  else 
+    msgs=`cat $tmpfile`
+    fatal_and_exit "-E- The local backup pool on $hostname, '$backup_pool' doesn't seem to exist: $msgs" "$mailto"
+  fi
 fi
+rm -f $tmpfile
 
-# Setup our backup marker names
-current_backup_marker=@current-backup-${local_pool_guid}
-previous_backup_marker=@previous-backup-${local_pool_guid}
+# Obtain the zpool guid for the local backup pool
+backup_pool_guid=`zpool get guid $backup_pool 2>&1 | grep $backup_pool | awk '{ print $3 }'`
+zpool get guid $backup_pool > /dev/null 2>&1
+if [ $? != 0 ]; then
+  fatal_and_exit "-E- Unable to extract the guid for the local backup pool on $hostname: $backup_pool" "$mailto"
+fi
 
-# Auto snapshot every zfs filesystem on the system specified below
-echo "$date ZFS replicate started" >> $logfile
-echo "$date ZFS replicate started" | tee -a $mylogfile
+# Setup our backup marker names
+current_backup_marker=@current-backup-${backup_pool_guid}
+previous_backup_marker=@previous-backup-${backup_pool_guid}
 
 # Sort the filesystems to replicate by the oldest backup first
-tmpfile=`tempfile`
 for filesystem in $filesystems_to_replicate; do
-  age=`snapshot_age $filesystem`
-  echo $filesystem $age >> $tmpfile
+  if [[ $filesystem =~ ':' ]]; then
+    dst_pool=${filesystem%%:*}
+    filesystem=${filesystem#*:} # remove src_pool from string
+  else
+    dst_pool=$backup_pool
+  fi
+  # Only backup filesystems that are specified to go this backup_pool
+  if [[ $backup_pool == $dst_pool ]]; then
+    age=`snapshot_age $filesystem`
+    echo $filesystem $age >> $tmpfile
+  fi
 done
 sorted_filesystems=`cat $tmpfile | sort -n -k 2 | awk '{ print $1 }'`
 rm -f $tmpfile
 
 # Replicate the sorted filesystems
 for filesystem in $sorted_filesystems; do
-  echo "-> Replicating $remote:$filesystem to ${local_pool}/${filesystem}" | tee -a $mylogfile
-  replicate $remote $filesystem
+  echo "-> Replicating $remote:$filesystem to ${backup_pool}/${filesystem}" | tee -a $mylogfile
+  replicate $remote $filesystem $backup_pool
+done
+
+# Export the local pool if told to do so
+if [[ $import_export_backup_pool == 1 ]]; then
+  # Don't export the pool if there is a currently running zfs-scrub operation
+  ps -ef | grep "zfs-scrub" | grep -q "${backup_pool}" | grep -v grep
+  if [ $? != 0 ]; then
+    zpool export $backup_pool >> $tmpfile 2>&1
+    if [ $? != 0 ]; then
+      sleep 300
+      zpool export $backup_pool >> $tmpfile 2>&1
+      if [ $? != 0 ]; then
+        lsof /$backup_pool/* >> $tmpfile 2>&1
+       msgs=`cat $tmpfile`
+        fatal_and_exit "-E- unable to export the local backup pool $backup_pool on $hostname: $msgs" "$mailto" 0
+      fi
+    fi
+  fi
+fi
+rm -f $tmpfile
+
 done
 
 # All done